#include <bits/stdc++.h>
#define pb push_back
#define dout if(dbg) cout

using namespace std;
typedef long long ll;

bool dbg = 0;

ll a[500001];

ll brK[65] = {0}, minDist[65] = {0}; // brKeceva
ll desnoKecevi[65];
ll najblizi[500001][64]; // za svaki br, najblizi za setovanje b-tog bita (mzd mogu oba)
bool moguOba[500001] = {0};
ll ls[65];

vector<ll> minimumi;

ll mDist(ll a, ll bit, ll ind)
{
    ll prviVeci = a;
    prviVeci |= ls[bit];
    if(bit != 0)
        prviVeci -= (a & desnoKecevi[bit-1]);
    // dout << "Prvi veci: " << prviVeci << endl;
    ll dist1 = abs(a - prviVeci);
    ll prviManji = a;
    if(ls[bit] > a)
    {
        najblizi[ind][bit] = prviVeci;
        return dist1;
    }
    if(bit != 0)
        prviManji -= (a & desnoKecevi[bit-1]);
    prviManji--;
    // dout << "Prvi manji: " << prviManji << endl;
    ll dist2 = a - prviManji;
    if(dist1 == dist2)
    {
        najblizi[ind][bit] = prviVeci;
        moguOba[ind] = 1;
        return dist1;
    }
    else if(dist1 > dist2)
    {
        najblizi[ind][bit] = prviManji;
        return dist2;
    }
    else
    {
        najblizi[ind][bit] = prviVeci;
        return dist1;
    }
}

ll llmax(ll a, ll b)
{
    if(a > b) return a;
    return b;
}

ll llmin(ll a, ll b)
{
    if(a < b) return a;
    return b;
}

int main()
{

    //cout << (ll)(((ll)1 << 64) - 1);
    if(!dbg)
    {
        ios::sync_with_stdio(false);
        cin.tie(0);
    }
    ls[0] = 1;
    ll maksBit = 2;
    for(ll i = 1; i < 64; i++)
        ls[i] = 2*ls[i-1];
    desnoKecevi[0] = 1;
    for(ll i = 1; i < 64; i++)
        desnoKecevi[i] = (ls[i] + desnoKecevi[i-1]);

    ll n;
    cin >> n;

    for(ll i = 0; i < n; i++)
    {
        cin >> a[i];
        moguOba[i] = false;
        maksBit = llmax(maksBit, (ll)log2(a[i]) + 1);
    }
    if(maksBit > 61) maksBit = 61;

    bool imaAnd = false, imaXor = false;
    for(ll b = 0; b <= maksBit; b++)
    {
        for(ll i = 0; i < n; i++)
        {
            najblizi[i][b] = 666666;
            bool bit = ((a[i] & ls[b]));
            brK[b] += bit;
            if((a[i] & ls[b]) == 0)
                minDist[b] += mDist(a[i], b, i);
        }
        imaAnd |= (brK[b] == n), imaXor |= (brK[b]&1);
        if(imaAnd && imaXor)
        {
            cout << 0;
            return 0;
        }
    }



    for(int i = 0; i <= maksBit; i++)
        if(minDist[i] < 0) minDist[i] = (((ll)1 << 63) - 1);

    ll minAnd = (ll)(((ll)1 << 63)-1);

    for(ll b = 0; b <= maksBit; b++)
        minAnd = llmin(minAnd, minDist[b]);

    for(ll b = 0; b <= maksBit; b++)
        if(minDist[b] == minAnd) minimumi.pb(b);


    for(ll b : minimumi)
    {
        for(ll bb = 0; bb <= maksBit; bb++)
        {
            ll brK;
            for(ll i = 0; i < n; i++)
            {
                if(najblizi[i][b] != 666666)
                {
                    if(moguOba[i])
                    {
                        // imamo dva izbora, mozemo nastelovati XOR
                        cout << minAnd;
                        return 0;
                    }
                    else
                    {
                        bool bit = (najblizi[i][b] & ls[bb]);
                        brK += bit;
                    }
                }
                else
                {
                    bool bit = (a[i] & ls[bb]);
                    brK += bit;
                }
            }
            if(brK&1)
            {
                cout << minAnd;
                return 0;
            }
        }
    }

    if(minimumi.size() == 1 && minimumi[0] == 0)
    {
        cout << minAnd + 2;
    }
    else
    {
        cout << minAnd + 1;
    }

    return 0;
}